from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, File, Int, Boolean

Partial_Least_Squares_Py_V0_1_0 = CommandToolBuilder(tool="partial_least_squares.py", base_command=["partial_least_squares.py"], inputs=[ToolInput(tag="in_input", input_type=String(optional=True), prefix="--input", doc=InputDocumentation(doc="Input dataset in wide format.")), ToolInput(tag="in_design", input_type=File(optional=True), prefix="--design", doc=InputDocumentation(doc="Design file.")), ToolInput(tag="in_id", input_type=String(optional=True), prefix="--ID", doc=InputDocumentation(doc="Name of the column with unique identifiers.")), ToolInput(tag="in_group", input_type=String(optional=True), prefix="--group", doc=InputDocumentation(doc="Name of the column with groups.")), ToolInput(tag="in_levels", input_type=String(optional=True), prefix="--levels", doc=InputDocumentation(doc="Different groups to sort by separeted by commas.")), ToolInput(tag="in_to_compare", input_type=String(optional=True), prefix="--toCompare", doc=InputDocumentation(doc="Name of the elements to compare in group col.")), ToolInput(tag="in_cross_validation", input_type=String(optional=True), prefix="--cross_validation", doc=InputDocumentation(doc="Choice of cross-validation procedure for the -nc\ndeterminantion: none, single, double.")), ToolInput(tag="in_n_comp", input_type=Int(optional=True), prefix="--nComp", doc=InputDocumentation(doc="Number of components.")), ToolInput(tag="in_out_scores", input_type=File(optional=True), prefix="--outScores", doc=InputDocumentation(doc="Name of output file to store loadings. TSV format.")), ToolInput(tag="in_out_weights", input_type=File(optional=True), prefix="--outWeights", doc=InputDocumentation(doc="Name of output file to store weights. TSV format.")), ToolInput(tag="in_out_classification", input_type=File(optional=True), prefix="--outClassification", doc=InputDocumentation(doc="Name of output file to store classification. TSV\nformat.")), ToolInput(tag="in_out_classification_accuracy", input_type=File(optional=True), prefix="--outClassificationAccuracy", doc=InputDocumentation(doc="Name of output file to store classification accuracy.\nTSV format.")), ToolInput(tag="in_figure", input_type=File(optional=True), prefix="--figure", doc=InputDocumentation(doc="Name of output file to store scatter plots for scores")), ToolInput(tag="in_palette", input_type=String(optional=True), prefix="--palette", doc=InputDocumentation(doc="Name of the palette to use.")), ToolInput(tag="in_color", input_type=String(optional=True), prefix="--color", doc=InputDocumentation(doc="Name of a valid color scheme on the selected palette")), ToolInput(tag="in_debug", input_type=Boolean(optional=True), prefix="--debug", doc=InputDocumentation(doc="Add debugging log output."))], outputs=[ToolOutput(tag="out_out_scores", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_scores", type_hint=File()), doc=OutputDocumentation(doc="Name of output file to store loadings. TSV format.")), ToolOutput(tag="out_out_weights", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_weights", type_hint=File()), doc=OutputDocumentation(doc="Name of output file to store weights. TSV format.")), ToolOutput(tag="out_out_classification", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_classification", type_hint=File()), doc=OutputDocumentation(doc="Name of output file to store classification. TSV\nformat.")), ToolOutput(tag="out_out_classification_accuracy", output_type=File(optional=True), selector=InputSelector(input_to_select="in_out_classification_accuracy", type_hint=File()), doc=OutputDocumentation(doc="Name of output file to store classification accuracy.\nTSV format.")), ToolOutput(tag="out_figure", output_type=File(optional=True), selector=InputSelector(input_to_select="in_figure", type_hint=File()), doc=OutputDocumentation(doc="Name of output file to store scatter plots for scores"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Partial_Least_Squares_Py_V0_1_0().translate("wdl", allow_empty_container=True)

